#include "camack.c"

#define ADC1            3
#define ADC2            5

#define OUTPUT_REGISTER 8
#define OUTPUT_REG_F    17
#define OUTPUT_REG_A    0

static long loop=0,data;
static int stat;

static void dc_int_init(),dc_int_start(),dc_int_stop(),dc_int_clear();

static void dc_int_init()
{
  dc_int_start();
}

static void dc_int_start()
{
  camac_write24(0x0000f0);
  camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,17);
  /*
    camac_write24(0x000000);
    camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,16);
    camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,16);
  */
  dc_int_clear();
}

static void dc_int_stop()
{
  camac_write24(0x000f00);
  camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,17);
  /*
    camac_write24(0x000000);
    camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,16);
    camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,16);
  */
}

static void dc_int_clear()
{
  static unsigned long i; static int j;
  camacNAF(ADC1,0,9,&i,&j);
  camacNAF(ADC2,0,9,&i,&j);
  camacNAF(ADC2,0,10,&i,&j);
  i=0x00000f;
  camacNAF(OUTPUT_REGISTER,OUTPUT_REG_A,17,&i,&j);
  /*
    i=0x000000;
    camacNAF(OUTPUT_REGISTER,OUTPUT_REG_A,16,&i,&j);
    i=0x00000f;
    camacNAF(OUTPUT_REGISTER,OUTPUT_REG_A,17,&i,&j);
    i=0x000000;
    camacNAF(OUTPUT_REGISTER,OUTPUT_REG_A,16,&i,&j);
    camacNAF(OUTPUT_REGISTER,OUTPUT_REG_A,16,&i,&j);
  */
}

static int dc_int(unsigned short buffer[])
{
  static long j;  
  static unsigned long pos,subevent_top,i,n,data;
  static int k;

  loop++;
  j=inl(BASE_ADDRESS+4);
  if(j==0)return(-1);
  if((j&0x10)==0)return(-1);
  buffer[1]=1;
  buffer[2]=1;
  pos=3;
  
  for(i=0;i<1000;i++){
    camacNAF(ADC2,0,8,&i,&k);
    if((k&0x01)!=0)goto acquisition;
  }
  return(-1);

 acquisition:

  /* gas counter*/
  subevent_top=pos++;
  buffer[pos++]=1;

  for(j=0;j<6;j++){
    camacNAF(ADC2,j,0,&i,&k);
    buffer[pos++]=i;
  }
  buffer[subevent_top]=pos-subevent_top;

  /* plastic counter*/
  subevent_top=pos++;
  buffer[pos++]=2;

  for(j=6;j<8;j++){
    camacNAF(ADC2,j,0,&i,&k);
    buffer[pos++]=i;
  }
  buffer[subevent_top]=pos-subevent_top;

  /* TOF */
  subevent_top=pos++;
  buffer[pos++]=3;

  for(j=8;j<11;j++){
    camacNAF(ADC2,j,0,&i,&k);
    buffer[pos++]=i;
  }
  buffer[subevent_top]=pos-subevent_top;


  buffer[0]=pos;
  return(0);
}

