/*****************************************************************************/
/*                                                                           */
/*   Offline Analyzer Program                       Version 1.0.0            */
/*                     for Linux-2.0.33 (slockware)                          */
/*                                                                           */
/*         Produced on 3 Dec 1997 by  Naohito Iwasa                          */
/*                                                                           */
/*****************************************************************************/
#include <stdio.h>
#include <fcntl.h>
#include "blocker.h"
#include <cfortran.h>
#include <hbook.h>

static unsigned short int buffer[BLOCK_LENGTH];
static unsigned short int events[BLOCK_LENGTH];
static unsigned char *cbuffer;

int main(int argc,char *argv[])
{
  char filename[256];
  int fd,blockno=0,pos,i,j,size;
  
  cbuffer=(char *)buffer;

  if(argc>1){
    if((fd=open(argv[1],O_RDONLY))>0)goto L15;
  }
 L1:
  while(1){
    printf("listmode filename \% ");
    fgets(filename,256,stdin);
    if((fd=open(filename,O_RDONLY))>0)break;
  }
  L15:
  while(read(fd,(char *)buffer,BLOCK_LENGTH*sizeof(short))>0){
  L2:
    blockno++;
    if(buffer[0]==0){  /* data block */
      printf("**************** DATA ** BLOCK %5d ************************\n",
	     blockno);
      pos=4;
      while(pos<BLOCK_LENGTH && buffer[pos]!=0xffff){
	/*	printf("%x\t",buffer[pos]);*/
	size=((buffer[pos])&0x7fff);
	if((((buffer[pos])&0x8000)!=0)&&(size<BLOCK_LENGTH)){
	  events[0]=size;
	  for(j=1;j<size;j++)
	    events[j]=buffer[pos+j];
	  analyze_("OFFLINE",events);
	  pos+=size;
	}
	else  pos++;
      }
    }
    else if(buffer[0]==1){  /* header block */
      printf("**************** HEADER ** BLOCK %5d ************************\n",
	     blockno);
      printf("%s\n",&cbuffer[0x14]);
      printf("%s\n",&cbuffer[0x64]);
    }
    else if(buffer[0]==2){  /* ender block */
      printf("**************** ENDER ** BLOCK %5d ************************\n",
	     blockno);
      printf("%s\n",&cbuffer[0x14]);
      printf("%s\n",&cbuffer[0x64]);
      if(read(fd,(char *)buffer,BLOCK_LENGTH*sizeof(short))>0){
	printf("The file has additional blocks.  ");
      L8:
	printf("Analyze them (Y/N)? ");
	fgets(filename,256,stdin);
	sscanf(filename,"%c",&i);
	if(i=='Y'||i=='y')goto L2;
	if(i!='N'&&i!='n')goto L8;
      }
    }
  }
L9:
  printf("append (Y/N)?");
  fgets(filename,256,stdin);
  sscanf(filename,"%c",&i);
  if(i=='Y'||i=='y')goto L1;
  if(i!='N'&&i!='n')goto L9;
}
